#ifndef D3Q27_KERNELS_H
#define D3Q27_KERNELS_H

//random numbers
#include <curand.h>
#include <curand_kernel.h>

extern "C" __global__ void LB_Kernel_Casc27(real s9,
                                            unsigned int* bcMatD,
                                            unsigned int* neighborX,
                                            unsigned int* neighborY,
                                            unsigned int* neighborZ,
                                            real* DDStart,
                                            int size_Mat,
                                            bool EvenOrOdd); 

extern "C" __global__ void LB_Kernel_Casc_SP_27(  real s9,
                                                  unsigned int* bcMatD,
                                                  unsigned int* neighborX,
                                                  unsigned int* neighborY,
                                                  unsigned int* neighborZ,
                                                  real* DDStart,
                                                  int size_Mat,
                                                  bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Casc_SP_MS_27(   real s9,
                                                      unsigned int* bcMatD,
                                                      unsigned int* neighborX,
                                                      unsigned int* neighborY,
                                                      unsigned int* neighborZ,
                                                      real* DDStart,
                                                      int size_Mat,
                                                      bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Casc_SP_MS_OHM_27(  real s9,
                                                         unsigned int* bcMatD,
                                                         unsigned int* neighborX,
                                                         unsigned int* neighborY,
                                                         unsigned int* neighborZ,
                                                         real* DDStart,
                                                         int size_Mat,
                                                         bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Casc_Kum_SP_27(real s9,
                                                    unsigned int* bcMatD,
                                                    unsigned int* neighborX,
                                                    unsigned int* neighborY,
                                                    unsigned int* neighborZ,
                                                    real* DDStart,
                                                    int size_Mat,
                                                    bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_BGK_Plus_SP_27(real omega,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_BGK_Plus_Comp_SP_27(real omega,
														 unsigned int* bcMatD,
														 unsigned int* neighborX,
														 unsigned int* neighborY,
														 unsigned int* neighborZ,
														 real* DDStart,
														 int size_Mat,
														 bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_BGK_Comp_SP_27(real omega,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_BGK_SP_27( real omega,
												unsigned int* bcMatD,
												unsigned int* neighborX,
												unsigned int* neighborY,
												unsigned int* neighborZ,
												real* DDStart,
												int size_Mat,
												bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_MRT_SP_27( real omega,
												unsigned int* bcMatD,
												unsigned int* neighborX,
												unsigned int* neighborY,
												unsigned int* neighborZ,
												real* DDStart,
												int size_Mat,
												bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_MRT_Comp_SP_27(real omega,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Cumulant_D3Q27All4(real omega,
														unsigned int* bcMatD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														real* DDStart,
														int size_Mat,
														int level,
														real* forces,
														bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Cumulant_D3Q27F3(	real omega,
														unsigned int* bcMatD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														real* DDStart,
														real* F3,
														int size_Mat,
														int level,
														real* forces,
														bool EvenOrOdd);

	
extern "C" __global__ void LB_Kernel_Kum_AA2016_Comp_Bulk_SP_27(real omega,
																unsigned int* bcMatD,
																unsigned int* neighborX,
																unsigned int* neighborY,
																unsigned int* neighborZ,
																real* DDStart,
																int size_Mat,
																int level,
																real* forces,
																bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_AA2016_Comp_SP_27(real omega,
														   unsigned int* bcMatD,
														   unsigned int* neighborX,
														   unsigned int* neighborY,
														   unsigned int* neighborZ,
														   real* DDStart,
														   int size_Mat,
														   int level,
														   real* forces,
														   bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_New_Comp_Sponge_SP_27(real omega,
														       unsigned int* bcMatD,
														       unsigned int* neighborX,
														       unsigned int* neighborY,
														       unsigned int* neighborZ,
													           real* coordX,
													           real* coordY,
													           real* coordZ,
														       real* DDStart,
														       int size_Mat,
														       bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_1h_SP_27(  real omega,
													real deltaPhi,
													real angularVelocity,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* coordX,
													real* coordY,
													real* coordZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Cascade_SP_27( real s9,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Cascade_Comp_SP_27(real s9,
														unsigned int* bcMatD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														real* DDStart,
														int size_Mat,
														bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_New_SP_27( real s9,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_New_Comp_Bulk_SP_27(real omega,
															 unsigned int* bcMatD,
															 unsigned int* neighborX,
															 unsigned int* neighborY,
															 unsigned int* neighborZ,
															 real* DDStart,
															 int size_Mat,
															 int level,
															 real* forces,
															 bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_New_Comp_SP_27(real omega,
														unsigned int* bcMatD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														real* DDStart,
														int size_Mat,
														int level,
														real* forces,
														bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_IsoTest_SP_27( real omega,
														unsigned int* bcMatD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														real* DDStart,
														real* dxxUx,
														real* dyyUy,
														real* dzzUz,
														int size_Mat,
														bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Kum_Comp_SP_27(real s9,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Wale_Cum_One_Comp_SP_27(real omega,
															 unsigned int* bcMatD,
															 unsigned int* neighborX,
															 unsigned int* neighborY,
															 unsigned int* neighborZ,
															 unsigned int* neighborWSB,
															 real* veloX,
															 real* veloY,
															 real* veloZ,
															 real* DDStart,
															 real* turbulentViscosity,
															 int size_Mat,
															 int level,
															 real* forces,
															 bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Wale_Cum_AA2016_Comp_SP_27( real omega,
																 unsigned int* bcMatD,
																 unsigned int* neighborX,
																 unsigned int* neighborY,
																 unsigned int* neighborZ,
																 unsigned int* neighborWSB,
																 real* veloX,
																 real* veloY,
																 real* veloZ,
																 real* DDStart,
																 real* turbulentViscosity,
																 int size_Mat,
																 int level,
																 real* forces,
																 bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_Wale_Cum_AA2016_Debug_Comp_SP_27(
	real omega_in,
	unsigned int* bcMatD,
	unsigned int* neighborX,
	unsigned int* neighborY,
	unsigned int* neighborZ,
	unsigned int* neighborWSB,
	real* veloX,
	real* veloY,
	real* veloZ,
	real* DDStart,
	real* turbulentViscosity,
	real* gSij,
	real* gSDij,
	real* gDxvx,
	real* gDyvx,
	real* gDzvx,
	real* gDxvy,
	real* gDyvy,
	real* gDzvy,
	real* gDxvz,
	real* gDyvz,
	real* gDzvz,
	int size_Mat,
	int level,
	real* forces,
	bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_WaleBySoniMalav_Cum_One_Comp_SP_27( real omega_in,
																		 unsigned int* bcMatD,
																		 unsigned int* neighborX,
																		 unsigned int* neighborY,
																		 unsigned int* neighborZ,
																		 unsigned int* neighborWSB,
																		 real* veloX,
																		 real* veloY,
																		 real* veloZ,
																		 real* DDStart,
																		 real* turbulentViscosity,
																		 int size_Mat,
																		 int level,
																		 real* forces,
																		 bool EvenOrOdd);


extern "C" __global__ void LB_Kernel_PM_Cum_One_Comp_SP_27( real omega,
															unsigned int* neighborX,
															unsigned int* neighborY,
															unsigned int* neighborZ,
															real* DDStart,
															int size_Mat,
															int level,
															real* forces,
															real porosity,
															real darcy,
															real forchheimer,
															unsigned int sizeOfPorousMedia,
															unsigned int* nodeIdsPorousMedia,
															bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_ThS7(real diffusivity,
                                          unsigned int* bcMatD,
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          real* DDStart,
                                          real* DD7,
                                          int size_Mat,
                                          bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_ThS27(real diffusivity,
                                           unsigned int* bcMatD,
                                           unsigned int* neighborX,
                                           unsigned int* neighborY,
                                           unsigned int* neighborZ,
                                           real* DDStart,
                                           real* DD27,
                                           int size_Mat,
                                           bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_AD_Incomp_7( real diffusivity,
												  unsigned int* bcMatD,
												  unsigned int* neighborX,
												  unsigned int* neighborY,
												  unsigned int* neighborZ,
												  real* DDStart,
												  real* DD7,
												  int size_Mat,
												  bool EvenOrOdd);

extern "C" __global__ void LB_Kernel_AD_Incomp_27( real diffusivity,
												   unsigned int* bcMatD,
												   unsigned int* neighborX,
												   unsigned int* neighborY,
												   unsigned int* neighborZ,
												   real* DDStart,
												   real* DD27,
												   int size_Mat,
												   bool EvenOrOdd);

extern "C" __global__ void LBInit27( int myid,
                                     int numprocs,
                                     real u0,
                                     unsigned int* geoD,
                                     unsigned int* neighborX,
                                     unsigned int* neighborY,
                                     unsigned int* neighborZ,
                                     real* vParabel,
                                     unsigned int size_Mat,
                                     unsigned int grid_nx, 
                                     unsigned int grid_ny, 
                                     unsigned int grid_nz, 
                                     real* DD,
                                     int lev,
                                     int maxlev);

extern "C" __global__ void LBInitF3(unsigned int* neighborX,
									unsigned int* neighborY,
									unsigned int* neighborZ,
									unsigned int* geoD,
									real* rho,
									real* ux,
									real* uy,
									real* uz,
									unsigned int size_Mat,
									real* G6,
									bool EvenOrOdd);

extern "C" __global__ void LBInitSP27( unsigned int* neighborX,
                                       unsigned int* neighborY,
                                       unsigned int* neighborZ,
                                       unsigned int* geoD,
                                       real* rho,
                                       real* ux,
                                       real* uy,
                                       real* uz,
                                       unsigned int size_Mat,
                                       real* DD,
                                       bool EvenOrOdd);

extern "C" __global__ void LBInitCompSP27( unsigned int* neighborX,
										   unsigned int* neighborY,
										   unsigned int* neighborZ,
										   unsigned int* geoD,
										   real* rho,
										   real* ux,
										   real* uy,
										   real* uz,
										   unsigned int size_Mat,
										   real* DD,
										   bool EvenOrOdd);

extern "C" __global__ void LBInitThS7( unsigned int* neighborX,
                                       unsigned int* neighborY,
                                       unsigned int* neighborZ,
                                       unsigned int* geoD,
                                       real* Conc,
                                       real* ux,
                                       real* uy,
                                       real* uz,
                                       unsigned int size_Mat,
                                       real* DD7,
                                       bool EvenOrOdd);

extern "C" __global__ void LBInitThS27(unsigned int* neighborX,
                                       unsigned int* neighborY,
                                       unsigned int* neighborZ,
                                       unsigned int* geoD,
                                       real* Conc,
                                       real* ux,
                                       real* uy,
                                       real* uz,
                                       unsigned int size_Mat,
                                       real* DD27,
                                       bool EvenOrOdd);

extern "C" __global__ void LBInitIncompAD7(unsigned int* neighborX,
										   unsigned int* neighborY,
										   unsigned int* neighborZ,
										   unsigned int* geoD,
										   real* Conc,
										   real* ux,
										   real* uy,
										   real* uz,
										   unsigned int size_Mat,
										   real* DD7,
										   bool EvenOrOdd);

extern "C" __global__ void LBInitIncompAD27(unsigned int* neighborX,
										    unsigned int* neighborY,
										    unsigned int* neighborZ,
										    unsigned int* geoD,
										    real* Conc,
										    real* ux,
										    real* uy,
										    real* uz,
										    unsigned int size_Mat,
										    real* DD27,
										    bool EvenOrOdd);

extern "C" __global__ void LBCalcMac27( real* vxD,
                                        real* vyD,
                                        real* vzD,
                                        real* rhoD,
                                        unsigned int* neighborX,
                                        unsigned int* neighborY,
                                        unsigned int* neighborZ,
                                        unsigned int* geoD,
                                        unsigned int size_Mat,
                                        real* DD,
                                        bool evenOrOdd);

extern "C" __global__ void LBCalcMacSP27( real* vxD,
                                          real* vyD,
                                          real* vzD,
                                          real* rhoD,
                                          real* pressD,
                                          unsigned int* geoD,
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat,
                                          real* DD,
                                          bool evenOrOdd);

extern "C" __global__ void LBCalcMacCompSP27( real* vxD,
											  real* vyD,
											  real* vzD,
											  real* rhoD,
											  real* pressD,
											  unsigned int* geoD,
											  unsigned int* neighborX,
											  unsigned int* neighborY,
											  unsigned int* neighborZ,
											  unsigned int size_Mat,
											  real* DD,
											  bool evenOrOdd);

extern "C" __global__ void LBCalcMacThS7( real* Conc,
                                          unsigned int* geoD,
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat,
                                          real* DD7,
                                          bool evenOrOdd);

extern "C" __global__ void GetPlaneConcThS7(real* Conc,
								            int* kPC,
								            unsigned int numberOfPointskPC,
											unsigned int* geoD,
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat,
											real* DD7,
											bool evenOrOdd);

extern "C" __global__ void GetPlaneConcThS27(real* Conc,
								             int* kPC,
								             unsigned int numberOfPointskPC,
											 unsigned int* geoD,
											 unsigned int* neighborX,
											 unsigned int* neighborY,
											 unsigned int* neighborZ,
											 unsigned int size_Mat,
											 real* DD27,
											 bool evenOrOdd);

extern "C" __global__ void LBCalcMacThS27(real* Conc,
                                          unsigned int* geoD,
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat,
                                          real* DD27,
                                          bool evenOrOdd);

extern "C" __global__ void LBCalcMedSP27( real* vxD,
                                          real* vyD,
                                          real* vzD,
                                          real* rhoD,
                                          real* pressD,
                                          unsigned int* geoD,
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat,
                                          real* DD,
                                          bool evenOrOdd);

extern "C" __global__ void LBCalcMedCompSP27( real* vxD,
											  real* vyD,
											  real* vzD,
											  real* rhoD,
											  real* pressD,
											  unsigned int* geoD,
											  unsigned int* neighborX,
											  unsigned int* neighborY,
											  unsigned int* neighborZ,
											  unsigned int size_Mat,
											  real* DD,
											  bool evenOrOdd);

extern "C" __global__ void LBCalcMacMedSP27( real* vxD,
                                             real* vyD,
                                             real* vzD,
                                             real* rhoD,
                                             real* pressD,
                                             unsigned int* geoD,
                                             unsigned int* neighborX,
                                             unsigned int* neighborY,
                                             unsigned int* neighborZ,
                                             unsigned int tdiff,
                                             unsigned int size_Mat,
                                             bool evenOrOdd);

extern "C" __global__ void LBResetMedianValuesSP27(
	real* vxD,
	real* vyD,
	real* vzD,
	real* rhoD,
	real* pressD,
	unsigned int size_Mat,
	bool evenOrOdd);


extern "C" __global__ void LBCalc2ndMomentsIncompSP27(  real* kxyFromfcNEQ,
														real* kyzFromfcNEQ,
														real* kxzFromfcNEQ,
														real* kxxMyyFromfcNEQ,
														real* kxxMzzFromfcNEQ,
														unsigned int* geoD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														unsigned int size_Mat,
														real* DD,
														bool evenOrOdd);

extern "C" __global__ void LBCalc2ndMomentsCompSP27(real* kxyFromfcNEQ,
													real* kyzFromfcNEQ,
													real* kxzFromfcNEQ,
													real* kxxMyyFromfcNEQ,
													real* kxxMzzFromfcNEQ,
													unsigned int* geoD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													unsigned int size_Mat,
													real* DD,
													bool evenOrOdd);

extern "C" __global__ void LBCalc3rdMomentsIncompSP27(  real* CUMbbb,
														real* CUMabc,
														real* CUMbac,
														real* CUMbca,
														real* CUMcba,
														real* CUMacb,
														real* CUMcab,
														unsigned int* bcMatD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														real* DDStart,
														int size_Mat,
														bool EvenOrOdd);

extern "C" __global__ void LBCalc3rdMomentsCompSP27(real* CUMbbb,
													real* CUMabc,
													real* CUMbac,
													real* CUMbca,
													real* CUMcba,
													real* CUMacb,
													real* CUMcab,
													unsigned int* bcMatD,
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													real* DDStart,
													int size_Mat,
													bool EvenOrOdd);

extern "C" __global__ void LBCalcHigherMomentsIncompSP27(   real* CUMcbb,
															real* CUMbcb,
															real* CUMbbc,
															real* CUMcca,
															real* CUMcac,
															real* CUMacc,
															real* CUMbcc,
															real* CUMcbc,
															real* CUMccb,
															real* CUMccc,
															unsigned int* bcMatD,
															unsigned int* neighborX,
															unsigned int* neighborY,
															unsigned int* neighborZ,
															real* DDStart,
															int size_Mat,
															bool EvenOrOdd);

extern "C" __global__ void LBCalcHigherMomentsCompSP27( real* CUMcbb,
														real* CUMbcb,
														real* CUMbbc,
														real* CUMcca,
														real* CUMcac,
														real* CUMacc,
														real* CUMbcc,
														real* CUMcbc,
														real* CUMccb,
														real* CUMccc,
														unsigned int* bcMatD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														real* DDStart,
														int size_Mat,
														bool EvenOrOdd);

extern "C" __global__ void LBCalcMeasurePoints(real* vxMP,
                                               real* vyMP,
                                               real* vzMP,
                                               real* rhoMP,
                                               unsigned int* kMP,
                                               unsigned int numberOfPointskMP,
                                               unsigned int MPClockCycle,
                                               unsigned int t,
                                               unsigned int* geoD,
                                               unsigned int* neighborX,
                                               unsigned int* neighborY,
                                               unsigned int* neighborZ,
                                               unsigned int size_Mat,
                                               real* DD,
                                               bool evenOrOdd);

extern "C" __global__ void LB_BC_Press_East27( int nx, 
                                               int ny, 
                                               int tz, 
                                               unsigned int* bcMatD, 
                                               unsigned int* neighborX,
                                               unsigned int* neighborY,
                                               unsigned int* neighborZ,
                                               real* DD, 
                                               unsigned int size_Mat, 
                                               bool evenOrOdd) ;

extern "C" __global__ void LB_BC_Vel_West_27( int nx, 
                                              int ny, 
                                              int nz, 
                                              int itz, 
                                              unsigned int* bcMatD, 
                                              unsigned int* neighborX,
                                              unsigned int* neighborY,
                                              unsigned int* neighborZ,
                                              real* DD, 
                                              unsigned int size_Mat, 
                                              bool evenOrOdd, 
                                              real u0x, 
                                              unsigned int grid_nx, 
                                              unsigned int grid_ny, 
                                              real om); 

extern "C" __global__ void QDevice27(int inx,
                                     int iny,
                                     real* DD, 
                                     int* k_Q, 
                                     real* QQ,
                                     unsigned int sizeQ,
                                     int kQ, 
                                     real minusomega, 
                                     unsigned int* neighborX,
                                     unsigned int* neighborY,
                                     unsigned int* neighborZ,
                                     unsigned int size_Mat, 
                                     bool evenOrOdd);

extern "C" __global__ void QDeviceComp27(int inx,
										 int iny,
										 real* DD, 
										 int* k_Q, 
										 real* QQ,
										 unsigned int sizeQ,
										 int kQ, 
										 real minusomega, 
										 unsigned int* neighborX,
										 unsigned int* neighborY,
										 unsigned int* neighborZ,
										 unsigned int size_Mat, 
										 bool evenOrOdd);

extern "C" __global__ void QDeviceCompThinWallsPartOne27(int inx,
														 int iny,
														 real* DD, 
														 int* k_Q, 
														 real* QQ,
														 unsigned int sizeQ,
														 int kQ, 
														 real om1, 
														 unsigned int* neighborX,
														 unsigned int* neighborY,
														 unsigned int* neighborZ,
														 unsigned int size_Mat, 
														 bool evenOrOdd);

extern "C" __global__ void QDeviceCompThinWallsPartTwo27(int inx,
														 int iny,
														 real* DD, 
														 int* k_Q, 
														 real* QQ,
														 unsigned int sizeQ,
														 int kQ, 
														 real om1, 
														 unsigned int* geom,
														 unsigned int* neighborX,
														 unsigned int* neighborY,
														 unsigned int* neighborZ,
														 unsigned int* neighborWSB,
														 unsigned int size_Mat, 
														 bool evenOrOdd);



extern "C" __global__ void QDevice3rdMomentsComp27(  int inx,
													 int iny,
													 real* DD, 
													 int* k_Q, 
													 real* QQ,
													 unsigned int sizeQ,
													 int kQ, 
													 real minusomega, 
													 unsigned int* neighborX,
													 unsigned int* neighborY,
													 unsigned int* neighborZ,
													 unsigned int size_Mat, 
													 bool evenOrOdd);

extern "C" __global__ void QDeviceIncompHighNu27(int inx,
												 int iny,
												 real* DD, 
												 int* k_Q, 
												 real* QQ,
												 unsigned int sizeQ,
												 int kQ, 
												 real om1, 
												 unsigned int* neighborX,
												 unsigned int* neighborY,
												 unsigned int* neighborZ,
												 unsigned int size_Mat, 
												 bool evenOrOdd);

extern "C" __global__ void QDeviceCompHighNu27(  int inx,
												 int iny,
												 real* DD, 
												 int* k_Q, 
												 real* QQ,
												 unsigned int sizeQ,
												 int kQ, 
												 real om1, 
												 unsigned int* neighborX,
												 unsigned int* neighborY,
												 unsigned int* neighborZ,
												 unsigned int size_Mat, 
												 bool evenOrOdd);

extern "C" __global__ void QVelDevPlainBB27(real* vx,
											real* vy,
											real* vz,
											real* DD,
											int* k_Q, 
											real* QQ,
											unsigned int sizeQ,
											int kQ, 
											real om1, 
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void QVelDevCouhette27(real* vx,
											real* vy,
											real* vz,
											real* DD,
											int* k_Q, 
											real* QQ,
											unsigned int sizeQ,
											int kQ, 
											real om1, 
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void QVelDev1h27( int inx,
										int iny,
										real* vx,
										real* vy,
										real* vz,
										real* DD, 
										int* k_Q, 
										real* QQ,
										unsigned int sizeQ,
										int kQ, 
										real om1,
										real Phi,
										real angularVelocity,
										unsigned int* neighborX,
										unsigned int* neighborY,
										unsigned int* neighborZ,
										real* coordX,
										real* coordY,
										real* coordZ,
										unsigned int size_Mat, 
										bool evenOrOdd);

extern "C" __global__ void QVelDevice27(int inx,
                                        int iny,
                                        real* vx,
                                        real* vy,
                                        real* vz,
                                        real* DD, 
                                        int* k_Q, 
                                        real* QQ,
                                        unsigned int sizeQ,
                                        int kQ, 
                                        real om1, 
                                        unsigned int* neighborX,
                                        unsigned int* neighborY,
                                        unsigned int* neighborZ,
                                        unsigned int size_Mat, 
                                        bool evenOrOdd);

extern "C" __global__ void QVelDeviceCompPlusSlip27(int inx,
													int iny,
													real* vx,
													real* vy,
													real* vz,
													real* DD, 
													int* k_Q, 
													real* QQ,
													unsigned int sizeQ,
													int kQ, 
													real om1, 
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													unsigned int size_Mat, 
													bool evenOrOdd);

extern "C" __global__ void QVelDeviceComp27(int inx,
											int iny,
											real* vx,
											real* vy,
											real* vz,
											real* DD, 
											int* k_Q, 
											real* QQ,
											unsigned int sizeQ,
											int kQ, 
											real om1, 
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void QVelDeviceCompZeroPress27(   int inx,
														int iny,
														real* vx,
														real* vy,
														real* vz,
														real* DD, 
														int* k_Q, 
														real* QQ,
														unsigned int sizeQ,
														//int kQ, 
														real om1, 
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														unsigned int size_Mat, 
														bool evenOrOdd);

extern "C" __global__ void QVelDeviceIncompHighNu27(int inx,
													int iny,
													real* vx,
													real* vy,
													real* vz,
													real* DD, 
													int* k_Q, 
													real* QQ,
													unsigned int sizeQ,
													int kQ, 
													real om1, 
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													unsigned int size_Mat, 
													bool evenOrOdd);

extern "C" __global__ void QVelDeviceCompHighNu27(  int inx,
													int iny,
													real* vx,
													real* vy,
													real* vz,
													real* DD, 
													int* k_Q, 
													real* QQ,
													unsigned int sizeQ,
													int kQ, 
													real om1, 
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													unsigned int size_Mat, 
													bool evenOrOdd);

extern "C" __global__ void QVeloDeviceEQ27(real* VeloX,
										   real* VeloY,
										   real* VeloZ,
                                           real* DD, 
                                           int* k_Q, 
                                           int kQ, 
                                           real om1, 
                                           unsigned int* neighborX,
                                           unsigned int* neighborY,
                                           unsigned int* neighborZ,
                                           unsigned int size_Mat, 
                                           bool evenOrOdd);

extern "C" __global__ void QSlipDevice27(real* DD, 
                                         int* k_Q, 
                                         real* QQ,
                                         unsigned int sizeQ,
                                         real om1, 
                                         unsigned int* neighborX,
                                         unsigned int* neighborY,
                                         unsigned int* neighborZ,
                                         unsigned int size_Mat, 
                                         bool evenOrOdd);

extern "C" __global__ void QSlipDeviceComp27(real* DD, 
											 int* k_Q, 
											 real* QQ,
											 unsigned int sizeQ,
											 real om1, 
											 unsigned int* neighborX,
											 unsigned int* neighborY,
											 unsigned int* neighborZ,
											 unsigned int size_Mat, 
											 bool evenOrOdd);

extern "C" __global__ void QSlipGeomDeviceComp27(real* DD, 
												 int* k_Q, 
												 real* QQ,
												 unsigned int sizeQ,
												 real om1, 
												 real* NormalX,
												 real* NormalY,
												 real* NormalZ,
												 unsigned int* neighborX,
												 unsigned int* neighborY,
												 unsigned int* neighborZ,
												 unsigned int size_Mat, 
												 bool evenOrOdd);

extern "C" __global__ void QSlipNormDeviceComp27(real* DD, 
												 int* k_Q, 
												 real* QQ,
												 unsigned int sizeQ,
												 real om1, 
												 real* NormalX,
												 real* NormalY,
												 real* NormalZ,
												 unsigned int* neighborX,
												 unsigned int* neighborY,
												 unsigned int* neighborZ,
												 unsigned int size_Mat, 
												 bool evenOrOdd);

extern "C" __global__ void QPressDevice27(int inx,
                                           int iny,
                                           real* rhoBC,
                                           real* DD, 
                                           int* k_Q, 
                                           real* QQ,
                                           unsigned int sizeQ,
                                           int kQ, 
                                           real om1, 
                                           unsigned int* neighborX,
                                           unsigned int* neighborY,
                                           unsigned int* neighborZ,
                                           unsigned int size_Mat, 
                                           bool evenOrOdd);

extern "C" __global__ void QPressDeviceAntiBB27(   real* rhoBC,
												   real* vx,
												   real* vy,
												   real* vz,
												   real* DD, 
												   int* k_Q, 
												   real* QQ,
												   int kQ, 
												   real om1, 
												   unsigned int* neighborX,
												   unsigned int* neighborY,
												   unsigned int* neighborZ,
												   unsigned int size_Mat, 
												   bool evenOrOdd);

extern "C" __global__ void QPressDeviceFixBackflow27( real* rhoBC,
                                                      real* DD, 
                                                      int* k_Q, 
                                                      int kQ, 
                                                      real om1, 
                                                      unsigned int* neighborX,
                                                      unsigned int* neighborY,
                                                      unsigned int* neighborZ,
                                                      unsigned int size_Mat, 
                                                      bool evenOrOdd);

extern "C" __global__ void QPressDeviceDirDepBot27(  real* rhoBC,
                                                     real* DD, 
                                                     int* k_Q, 
                                                     int kQ, 
                                                     real om1, 
                                                     unsigned int* neighborX,
                                                     unsigned int* neighborY,
                                                     unsigned int* neighborZ,
                                                     unsigned int size_Mat, 
                                                     bool evenOrOdd);

extern "C" __global__ void QPressNoRhoDevice27(  real* rhoBC,
												 real* DD, 
												 int* k_Q, 
												 int* k_N, 
												 int kQ, 
												 real om1, 
												 unsigned int* neighborX,
												 unsigned int* neighborY,
												 unsigned int* neighborZ,
												 unsigned int size_Mat, 
												 bool evenOrOdd);

extern "C" __global__ void QInflowScaleByPressDevice27(  real* rhoBC,
														 real* DD, 
														 int* k_Q, 
														 int* k_N, 
														 int kQ, 
														 real om1, 
														 unsigned int* neighborX,
														 unsigned int* neighborY,
														 unsigned int* neighborZ,
														 unsigned int size_Mat, 
														 bool evenOrOdd);

extern "C" __global__ void QPressDeviceOld27(real* rhoBC,
                                             real* DD, 
                                             int* k_Q, 
                                             int* k_N, 
                                             int kQ, 
                                             real om1, 
                                             unsigned int* neighborX,
                                             unsigned int* neighborY,
                                             unsigned int* neighborZ,
                                             unsigned int size_Mat, 
                                             bool evenOrOdd);

extern "C" __global__ void QPressDeviceIncompNEQ27( real* rhoBC,
													real* DD, 
													int* k_Q, 
													int* k_N, 
													int kQ, 
													real om1, 
													unsigned int* neighborX,
													unsigned int* neighborY,
													unsigned int* neighborZ,
													unsigned int size_Mat, 
													bool evenOrOdd);

extern "C" __global__ void QPressDeviceNEQ27(real* rhoBC,
                                             real* DD, 
                                             int* k_Q, 
                                             int* k_N, 
                                             int kQ, 
                                             real om1, 
                                             unsigned int* neighborX,
                                             unsigned int* neighborY,
                                             unsigned int* neighborZ,
                                             unsigned int size_Mat, 
                                             bool evenOrOdd);

extern "C" __global__ void QPressDeviceEQZ27(real* rhoBC,
                                             real* DD, 
                                             int* k_Q, 
                                             int* k_N, 
                                             real* kTestRE, 
                                             int kQ, 
                                             real om1, 
                                             unsigned int* neighborX,
                                             unsigned int* neighborY,
                                             unsigned int* neighborZ,
                                             unsigned int size_Mat, 
                                             bool evenOrOdd);

extern "C" __global__ void QPressDeviceZero27(  real* DD, 
												int* k_Q, 
												unsigned int kQ, 
												unsigned int* neighborX,
												unsigned int* neighborY,
												unsigned int* neighborZ,
												unsigned int size_Mat, 
												bool evenOrOdd);

extern "C" __global__ void QPressDeviceFake27(real* rhoBC,
                                             real* DD, 
                                             int* k_Q, 
                                             int* k_N, 
                                             int kQ, 
                                             real om1, 
                                             unsigned int* neighborX,
                                             unsigned int* neighborY,
                                             unsigned int* neighborZ,
                                             unsigned int size_Mat, 
                                             bool evenOrOdd);

extern "C" __global__ void BBDevice27(int inx,
                                     int iny,
                                     real* DD, 
                                     int* k_Q, 
                                     real* QQ,
                                     unsigned int sizeQ,
                                     int kQ, 
                                     real om1, 
                                     unsigned int* neighborX,
                                     unsigned int* neighborY,
                                     unsigned int* neighborZ,
                                     unsigned int size_Mat, 
                                     bool evenOrOdd);

extern "C" __global__ void QPressDevice27_IntBB(real* rho,
												real* DD, 
												int* k_Q, 
												real* QQ,
												unsigned int sizeQ,
												int kQ, 
												real om1, 
												unsigned int* neighborX,
												unsigned int* neighborY,
												unsigned int* neighborZ,
												unsigned int size_Mat, 
												bool evenOrOdd);

extern "C" __global__ void PressSchlaff27(real* rhoBC,
                                          real* DD,
                                          real* vx0,
                                          real* vy0,
                                          real* vz0,
                                          real* deltaVz0,
                                          int* k_Q, 
                                          int* k_N, 
                                          int kQ, 
                                          real om1, 
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat, 
                                          bool evenOrOdd);

extern "C" __global__ void VelSchlaff27(  int t,
                                          real* DD,
                                          real* vz0,
                                          real* deltaVz0,
                                          int* k_Q, 
                                          int* k_N, 
                                          int kQ, 
                                          real om1, 
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat, 
                                          bool evenOrOdd);

extern "C" __global__ void QAD7( int inx,
                                 int iny,
                                 real* DD, 
                                 real* DD7, 
                                 real* temp,
                                 real diffusivity,
                                 int* k_Q, 
                                 real* QQ,
                                 unsigned int sizeQ,
                                 int kQ, 
                                 real om1, 
                                 unsigned int* neighborX,
                                 unsigned int* neighborY,
                                 unsigned int* neighborZ,
                                 unsigned int size_Mat, 
                                 bool evenOrOdd);

extern "C" __global__ void QADDirichlet27(   int inx,
											 int iny,
											 real* DD, 
											 real* DD27, 
											 real* temp, 
											 real diffusivity,
											 int* k_Q, 
											 real* QQ,
											 unsigned int sizeQ,
											 int kQ, 
											 real om1, 
											 unsigned int* neighborX,
											 unsigned int* neighborY,
											 unsigned int* neighborZ,
											 unsigned int size_Mat, 
											 bool evenOrOdd);

extern "C" __global__ void QADBB27(  int inx,
									 int iny,
									 real* DD, 
									 real* DD27, 
									 real* temp, 
									 real diffusivity,
									 int* k_Q, 
									 real* QQ,
									 unsigned int sizeQ,
									 int kQ, 
									 real om1, 
									 unsigned int* neighborX,
									 unsigned int* neighborY,
									 unsigned int* neighborZ,
									 unsigned int size_Mat, 
									 bool evenOrOdd);

extern "C" __global__ void QADVel7( int inx,
                                    int iny,
                                    real* DD, 
                                    real* DD7, 
                                    real* temp,
                                    real* velo,
                                    real diffusivity,
                                    int* k_Q, 
                                    real* QQ,
                                    unsigned int sizeQ,
                                    int kQ, 
                                    real om1, 
                                    unsigned int* neighborX,
                                    unsigned int* neighborY,
                                    unsigned int* neighborZ,
                                    unsigned int size_Mat, 
                                    bool evenOrOdd);

extern "C" __global__ void QADVel27(int inx,
                                    int iny,
                                    real* DD, 
                                    real* DD27, 
                                    real* temp, 
                                    real* velo, 
                                    real diffusivity,
                                    int* k_Q, 
                                    real* QQ,
                                    unsigned int sizeQ,
                                    int kQ, 
                                    real om1, 
                                    unsigned int* neighborX,
                                    unsigned int* neighborY,
                                    unsigned int* neighborZ,
                                    unsigned int size_Mat, 
                                    bool evenOrOdd);

extern "C" __global__ void QADPress7(  int inx,
                                       int iny,
                                       real* DD, 
                                       real* DD7, 
                                       real* temp,
                                       real* velo,
                                       real diffusivity,
                                       int* k_Q, 
                                       real* QQ,
                                       unsigned int sizeQ,
                                       int kQ, 
                                       real om1, 
                                       unsigned int* neighborX,
                                       unsigned int* neighborY,
                                       unsigned int* neighborZ,
                                       unsigned int size_Mat, 
                                       bool evenOrOdd);

extern "C" __global__ void QADPress27( int inx,
                                       int iny,
                                       real* DD, 
                                       real* DD27, 
                                       real* temp, 
                                       real* velo, 
                                       real diffusivity,
                                       int* k_Q, 
                                       real* QQ,
                                       unsigned int sizeQ,
                                       int kQ, 
                                       real om1, 
                                       unsigned int* neighborX,
                                       unsigned int* neighborY,
                                       unsigned int* neighborZ,
                                       unsigned int size_Mat, 
                                       bool evenOrOdd);

extern "C" __global__ void QNoSlipADincomp7( int inx,
											 int iny,
											 real* DD, 
											 real* DD7, 
											 real* temp,
											 real diffusivity,
											 int* k_Q, 
											 real* QQ,
											 unsigned int sizeQ,
											 int kQ, 
											 real om1, 
											 unsigned int* neighborX,
											 unsigned int* neighborY,
											 unsigned int* neighborZ,
											 unsigned int size_Mat, 
											 bool evenOrOdd);

extern "C" __global__ void QNoSlipADincomp27(int inx,
											 int iny,
											 real* DD, 
											 real* DD27, 
											 real* temp, 
											 real diffusivity,
											 int* k_Q, 
											 real* QQ,
											 unsigned int sizeQ,
											 int kQ, 
											 real om1, 
											 unsigned int* neighborX,
											 unsigned int* neighborY,
											 unsigned int* neighborZ,
											 unsigned int size_Mat, 
											 bool evenOrOdd);

extern "C" __global__ void QADVeloIncomp7(  int inx,
											int iny,
											real* DD, 
											real* DD7, 
											real* temp,
											real* velo,
											real diffusivity,
											int* k_Q, 
											real* QQ,
											unsigned int sizeQ,
											int kQ, 
											real om1, 
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void QADVeloIncomp27( int inx,
											int iny,
											real* DD, 
											real* DD27, 
											real* temp, 
											real* velo, 
											real diffusivity,
											int* k_Q, 
											real* QQ,
											unsigned int sizeQ,
											int kQ, 
											real om1, 
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void QADPressIncomp7(int inx,
										   int iny,
										   real* DD, 
										   real* DD7, 
										   real* temp,
										   real* velo,
										   real diffusivity,
										   int* k_Q, 
										   real* QQ,
										   unsigned int sizeQ,
										   int kQ, 
										   real om1, 
										   unsigned int* neighborX,
										   unsigned int* neighborY,
										   unsigned int* neighborZ,
										   unsigned int size_Mat, 
										   bool evenOrOdd);

extern "C" __global__ void QADPressIncomp27(   int inx,
											   int iny,
											   real* DD, 
											   real* DD27, 
											   real* temp, 
											   real* velo, 
											   real diffusivity,
											   int* k_Q, 
											   real* QQ,
											   unsigned int sizeQ,
											   int kQ, 
											   real om1, 
											   unsigned int* neighborX,
											   unsigned int* neighborY,
											   unsigned int* neighborZ,
											   unsigned int size_Mat, 
											   bool evenOrOdd);

extern "C" __global__ void PropellerBC(unsigned int* neighborX,
                                       unsigned int* neighborY,
                                       unsigned int* neighborZ,
                                       real* rho,
                                       real* ux,
                                       real* uy,
                                       real* uz,
                                       int* k_Q, 
									   unsigned int size_Prop,
                                       unsigned int size_Mat,
                                       unsigned int* bcMatD,
                                       real* DD,
                                       bool EvenOrOdd);



//coarse to fine
extern "C" __global__ void scaleCF27(real* DC, 
                                     real* DF, 
                                    unsigned int* neighborCX,
                                    unsigned int* neighborCY,
                                    unsigned int* neighborCZ,
                                    unsigned int* neighborFX,
                                    unsigned int* neighborFY,
                                    unsigned int* neighborFZ,
										       unsigned int size_MatC, 
										       unsigned int size_MatF, 
										       bool evenOrOdd,
                                     unsigned int* posCSWB, 
                                     unsigned int* posFSWB, 
                                     unsigned int kCF, 
										       real omCoarse, 
										       real omFine, 
										       real nu, 
										       unsigned int nxC, 
										       unsigned int nyC, 
										       unsigned int nxF, 
										       unsigned int nyF);

extern "C" __global__ void scaleCFEff27(real* DC, 
                                        real* DF, 
                                        unsigned int* neighborCX,
                                        unsigned int* neighborCY,
                                        unsigned int* neighborCZ,
                                        unsigned int* neighborFX,
                                        unsigned int* neighborFY,
                                        unsigned int* neighborFZ,
									             unsigned int size_MatC, 
									             unsigned int size_MatF, 
									             bool evenOrOdd,
                                        unsigned int* posCSWB, 
                                        unsigned int* posFSWB, 
                                        unsigned int kCF, 
									             real omCoarse, 
									             real omFine, 
									             real nu, 
									             unsigned int nxC, 
									             unsigned int nyC, 
									             unsigned int nxF, 
                                        unsigned int nyF,
                                        OffCF offCF);

extern "C" __global__ void scaleCFLast27( real* DC, 
                                          real* DF, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posCSWB, 
                                          unsigned int* posFSWB, 
                                          unsigned int kCF, 
                                          real omCoarse, 
                                          real omFine, 
                                          real nu, 
                                          unsigned int nxC, 
                                          unsigned int nyC, 
                                          unsigned int nxF, 
                                          unsigned int nyF,
                                          OffCF offCF);

extern "C" __global__ void scaleCFpress27(real* DC, 
                                          real* DF, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posCSWB, 
                                          unsigned int* posFSWB, 
                                          unsigned int kCF, 
                                          real omCoarse, 
                                          real omFine, 
                                          real nu, 
                                          unsigned int nxC, 
                                          unsigned int nyC, 
                                          unsigned int nxF, 
                                          unsigned int nyF,
                                          OffCF offCF);

extern "C" __global__ void scaleCF_Fix_27(real* DC, 
                                          real* DF, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posCSWB, 
                                          unsigned int* posFSWB, 
                                          unsigned int kCF, 
                                          real omCoarse, 
                                          real omFine, 
                                          real nu, 
                                          unsigned int nxC, 
                                          unsigned int nyC, 
                                          unsigned int nxF, 
                                          unsigned int nyF,
                                          OffCF offCF);

extern "C" __global__ void scaleCF_Fix_comp_27(   real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posCSWB, 
												  unsigned int* posFSWB, 
												  unsigned int kCF, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffCF offCF);

extern "C" __global__ void scaleCF_0817_comp_27(  real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posCSWB, 
												  unsigned int* posFSWB, 
												  unsigned int kCF, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffCF offCF);

extern "C" __global__ void scaleCF_comp_D3Q27F3( real* DC,
												 real* DF,
												 real* G6,
												 unsigned int* neighborCX,
												 unsigned int* neighborCY,
												 unsigned int* neighborCZ,
												 unsigned int* neighborFX,
												 unsigned int* neighborFY,
												 unsigned int* neighborFZ,
												 unsigned int size_MatC, 
												 unsigned int size_MatF, 
												 bool evenOrOdd,
												 unsigned int* posCSWB, 
												 unsigned int* posFSWB, 
												 unsigned int kCF, 
												 real omCoarse, 
												 real omFine, 
												 real nu, 
												 unsigned int nxC, 
												 unsigned int nyC, 
												 unsigned int nxF, 
												 unsigned int nyF,
												 OffCF offCF);


extern "C" __global__ void scaleCF_staggered_time_comp_27(real* DC, 
														  real* DF, 
														  unsigned int* neighborCX,
														  unsigned int* neighborCY,
														  unsigned int* neighborCZ,
														  unsigned int* neighborFX,
														  unsigned int* neighborFY,
														  unsigned int* neighborFZ,
														  unsigned int size_MatC, 
														  unsigned int size_MatF, 
														  bool evenOrOdd,
														  unsigned int* posCSWB, 
														  unsigned int* posFSWB, 
														  unsigned int kCF, 
														  real omCoarse, 
														  real omFine, 
														  real nu, 
														  unsigned int nxC, 
														  unsigned int nyC, 
														  unsigned int nxF, 
														  unsigned int nyF,
														  OffCF offCF);

extern "C" __global__ void scaleCF_RhoSq_comp_27( real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posCSWB, 
												  unsigned int* posFSWB, 
												  unsigned int kCF, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffCF offCF);

extern "C" __global__ void scaleCF_RhoSq_3rdMom_comp_27(real* DC, 
														real* DF, 
														unsigned int* neighborCX,
														unsigned int* neighborCY,
														unsigned int* neighborCZ,
														unsigned int* neighborFX,
														unsigned int* neighborFY,
														unsigned int* neighborFZ,
														unsigned int size_MatC, 
														unsigned int size_MatF, 
														bool evenOrOdd,
														unsigned int* posCSWB, 
														unsigned int* posFSWB, 
														unsigned int kCF, 
														real omCoarse, 
														real omFine, 
														real nu, 
														unsigned int nxC, 
														unsigned int nyC, 
														unsigned int nxF, 
														unsigned int nyF,
														OffCF offCF);

extern "C" __global__ void scaleCF_AA2016_comp_27(real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posCSWB, 
												  unsigned int* posFSWB, 
												  unsigned int kCF, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffCF offCF);

extern "C" __global__ void scaleCF_NSPress_27(real* DC, 
											  real* DF, 
											  unsigned int* neighborCX,
											  unsigned int* neighborCY,
											  unsigned int* neighborCZ,
											  unsigned int* neighborFX,
											  unsigned int* neighborFY,
											  unsigned int* neighborFZ,
											  unsigned int size_MatC, 
											  unsigned int size_MatF, 
											  bool evenOrOdd,
											  unsigned int* posCSWB, 
											  unsigned int* posFSWB, 
											  unsigned int kCF, 
											  real omCoarse, 
											  real omFine, 
											  real nu, 
											  unsigned int nxC, 
											  unsigned int nyC, 
											  unsigned int nxF, 
											  unsigned int nyF,
											  OffCF offCF);

extern "C" __global__ void scaleCFThSMG7( real* DC, 
                                          real* DF,
                                          real* DD7C, 
                                          real* DD7F, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posCSWB, 
                                          unsigned int* posFSWB, 
                                          unsigned int kCF, 
                                          real nu,
                                          real diffusivity_fine,
                                          OffCF offCF);

extern "C" __global__ void scaleCFThS7(real* DC, 
                                       real* DF,
                                       real* DD7C, 
                                       real* DD7F, 
                                       unsigned int* neighborCX,
                                       unsigned int* neighborCY,
                                       unsigned int* neighborCZ,
                                       unsigned int* neighborFX,
                                       unsigned int* neighborFY,
                                       unsigned int* neighborFZ,
                                       unsigned int size_MatC, 
                                       unsigned int size_MatF, 
                                       bool evenOrOdd,
                                       unsigned int* posCSWB, 
                                       unsigned int* posFSWB, 
                                       unsigned int kCF, 
                                       real nu,
                                       real diffusivity_fine);

extern "C" __global__ void scaleCFThS27(real* DC, 
                                        real* DF,
                                        real* DD27C, 
                                        real* DD27F, 
                                        unsigned int* neighborCX,
                                        unsigned int* neighborCY,
                                        unsigned int* neighborCZ,
                                        unsigned int* neighborFX,
                                        unsigned int* neighborFY,
                                        unsigned int* neighborFZ,
                                        unsigned int size_MatC, 
                                        unsigned int size_MatF, 
                                        bool evenOrOdd,
                                        unsigned int* posCSWB, 
                                        unsigned int* posFSWB, 
                                        unsigned int kCF, 
                                        real nu,
                                        real diffusivity_fine,
										OffCF offCF);

//fine to coarse 
extern "C" __global__ void scaleFC27(real* DC, 
                                     real* DF, 
                                    unsigned int* neighborCX,
                                    unsigned int* neighborCY,
                                    unsigned int* neighborCZ,
                                    unsigned int* neighborFX,
                                    unsigned int* neighborFY,
                                    unsigned int* neighborFZ,
										       unsigned int size_MatC, 
										       unsigned int size_MatF, 
										       bool evenOrOdd,
                                     unsigned int* posC, 
                                     unsigned int* posFSWB, 
                                     unsigned int kFC, 
										       real omCoarse, 
										       real omFine, 
										       real nu, 
										       unsigned int nxC, 
										       unsigned int nyC, 
										       unsigned int nxF, 
                                     unsigned int nyF);

extern "C" __global__ void scaleFCEff27(real* DC, 
                                        real* DF, 
                                        unsigned int* neighborCX,
                                        unsigned int* neighborCY,
                                        unsigned int* neighborCZ,
                                        unsigned int* neighborFX,
                                        unsigned int* neighborFY,
                                        unsigned int* neighborFZ,
                                        unsigned int size_MatC, 
                                        unsigned int size_MatF, 
                                        bool evenOrOdd,
                                        unsigned int* posC, 
                                        unsigned int* posFSWB, 
                                        unsigned int kFC, 
                                        real omCoarse, 
                                        real omFine, 
                                        real nu, 
                                        unsigned int nxC, 
                                        unsigned int nyC, 
                                        unsigned int nxF, 
                                        unsigned int nyF,
                                        OffFC offFC);

extern "C" __global__ void scaleFCLast27( real* DC, 
                                          real* DF, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posC, 
                                          unsigned int* posFSWB, 
                                          unsigned int kFC, 
                                          real omCoarse, 
                                          real omFine, 
                                          real nu, 
                                          unsigned int nxC, 
                                          unsigned int nyC, 
                                          unsigned int nxF, 
                                          unsigned int nyF,
                                          OffFC offFC);

extern "C" __global__ void scaleFCpress27( real* DC, 
                                          real* DF, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posC, 
                                          unsigned int* posFSWB, 
                                          unsigned int kFC, 
                                          real omCoarse, 
                                          real omFine, 
                                          real nu, 
                                          unsigned int nxC, 
                                          unsigned int nyC, 
                                          unsigned int nxF, 
                                          unsigned int nyF,
                                          OffFC offFC);

extern "C" __global__ void scaleFC_Fix_27( real* DC, 
                                          real* DF, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posC, 
                                          unsigned int* posFSWB, 
                                          unsigned int kFC, 
                                          real omCoarse, 
                                          real omFine, 
                                          real nu, 
                                          unsigned int nxC, 
                                          unsigned int nyC, 
                                          unsigned int nxF, 
                                          unsigned int nyF,
                                          OffFC offFC);

extern "C" __global__ void scaleFC_Fix_comp_27(   real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posC, 
												  unsigned int* posFSWB, 
												  unsigned int kFC, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffFC offFC);

extern "C" __global__ void scaleFC_0817_comp_27(  real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posC, 
												  unsigned int* posFSWB, 
												  unsigned int kFC, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffFC offFC);

extern "C" __global__ void scaleFC_comp_D3Q27F3( real* DC,
												 real* DF,
												 real* G6,
												 unsigned int* neighborCX,
												 unsigned int* neighborCY,
												 unsigned int* neighborCZ,
												 unsigned int* neighborFX,
												 unsigned int* neighborFY,
												 unsigned int* neighborFZ,
												 unsigned int size_MatC, 
												 unsigned int size_MatF, 
												 bool evenOrOdd,
												 unsigned int* posC, 
												 unsigned int* posFSWB, 
												 unsigned int kFC, 
												 real omCoarse, 
												 real omFine, 
												 real nu, 
												 unsigned int nxC, 
												 unsigned int nyC, 
												 unsigned int nxF, 
												 unsigned int nyF,
												 OffFC offFC);


extern "C" __global__ void scaleFC_staggered_time_comp_27(real* DC, 
														  real* DF, 
														  unsigned int* neighborCX,
														  unsigned int* neighborCY,
														  unsigned int* neighborCZ,
														  unsigned int* neighborFX,
														  unsigned int* neighborFY,
														  unsigned int* neighborFZ,
														  unsigned int size_MatC, 
														  unsigned int size_MatF, 
														  bool evenOrOdd,
														  unsigned int* posC, 
														  unsigned int* posFSWB, 
														  unsigned int kFC, 
														  real omCoarse, 
														  real omFine, 
														  real nu, 
														  unsigned int nxC, 
														  unsigned int nyC, 
														  unsigned int nxF, 
														  unsigned int nyF,
														  OffFC offFC);

extern "C" __global__ void scaleFC_RhoSq_comp_27( real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posC, 
												  unsigned int* posFSWB, 
												  unsigned int kFC, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffFC offFC);

extern "C" __global__ void scaleFC_RhoSq_3rdMom_comp_27(real* DC, 
														real* DF, 
														unsigned int* neighborCX,
														unsigned int* neighborCY,
														unsigned int* neighborCZ,
														unsigned int* neighborFX,
														unsigned int* neighborFY,
														unsigned int* neighborFZ,
														unsigned int size_MatC, 
														unsigned int size_MatF, 
														bool evenOrOdd,
														unsigned int* posC, 
														unsigned int* posFSWB, 
														unsigned int kFC, 
														real omCoarse, 
														real omFine, 
														real nu, 
														unsigned int nxC, 
														unsigned int nyC, 
														unsigned int nxF, 
														unsigned int nyF,
														OffFC offFC);

extern "C" __global__ void scaleFC_AA2016_comp_27(real* DC, 
												  real* DF, 
												  unsigned int* neighborCX,
												  unsigned int* neighborCY,
												  unsigned int* neighborCZ,
												  unsigned int* neighborFX,
												  unsigned int* neighborFY,
												  unsigned int* neighborFZ,
												  unsigned int size_MatC, 
												  unsigned int size_MatF, 
												  bool evenOrOdd,
												  unsigned int* posC, 
												  unsigned int* posFSWB, 
												  unsigned int kFC, 
												  real omCoarse, 
												  real omFine, 
												  real nu, 
												  unsigned int nxC, 
												  unsigned int nyC, 
												  unsigned int nxF, 
												  unsigned int nyF,
												  OffFC offFC);

extern "C" __global__ void scaleFC_NSPress_27(real* DC, 
											  real* DF, 
											  unsigned int* neighborCX,
											  unsigned int* neighborCY,
											  unsigned int* neighborCZ,
											  unsigned int* neighborFX,
											  unsigned int* neighborFY,
											  unsigned int* neighborFZ,
											  unsigned int size_MatC, 
											  unsigned int size_MatF, 
											  bool evenOrOdd,
											  unsigned int* posC, 
											  unsigned int* posFSWB, 
											  unsigned int kFC, 
											  real omCoarse, 
											  real omFine, 
											  real nu, 
											  unsigned int nxC, 
											  unsigned int nyC, 
											  unsigned int nxF, 
											  unsigned int nyF,
											  OffFC offFC);

extern "C" __global__ void scaleFCThSMG7( real* DC, 
                                          real* DF, 
                                          real* DD7C, 
                                          real* DD7F, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posC, 
                                          unsigned int* posFSWB, 
                                          unsigned int kFC, 
                                          real nu,
                                          real diffusivity_coarse,
                                          OffFC offFC);

extern "C" __global__ void scaleFCThS7(real* DC, 
                                       real* DF, 
                                       real* DD7C, 
                                       real* DD7F, 
                                       unsigned int* neighborCX,
                                       unsigned int* neighborCY,
                                       unsigned int* neighborCZ,
                                       unsigned int* neighborFX,
                                       unsigned int* neighborFY,
                                       unsigned int* neighborFZ,
                                       unsigned int size_MatC, 
                                       unsigned int size_MatF, 
                                       bool evenOrOdd,
                                       unsigned int* posC, 
                                       unsigned int* posFSWB, 
                                       unsigned int kFC, 
                                       real nu,
                                       real diffusivity_coarse);

extern "C" __global__ void scaleFCThS27(  real* DC, 
                                          real* DF, 
                                          real* DD27C, 
                                          real* DD27F, 
                                          unsigned int* neighborCX,
                                          unsigned int* neighborCY,
                                          unsigned int* neighborCZ,
                                          unsigned int* neighborFX,
                                          unsigned int* neighborFY,
                                          unsigned int* neighborFZ,
                                          unsigned int size_MatC, 
                                          unsigned int size_MatF, 
                                          bool evenOrOdd,
                                          unsigned int* posC, 
                                          unsigned int* posFSWB, 
                                          unsigned int kFC, 
                                          real nu,
                                          real diffusivity_coarse,
										  OffFC offFC);

extern "C" __global__ void DragLiftPost27(  real* DD, 
											int* k_Q, 
											real* QQ,
											int kQ, 
											double *DragX,
											double *DragY,
											double *DragZ,
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void DragLiftPre27(   real* DD, 
											int* k_Q, 
											real* QQ,
											int kQ, 
											double *DragX,
											double *DragY,
											double *DragZ,
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void CalcCP27(real* DD, 
									int* cpIndex, 
									int nonCp, 
									double *cpPress,
									unsigned int* neighborX,
									unsigned int* neighborY,
									unsigned int* neighborZ,
									unsigned int size_Mat, 
									bool evenOrOdd);

extern "C" __global__ void getSendFsPre27(real* DD,
										  real* bufferFs,
										  int* sendIndex,
                                          int buffmax,
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat, 
                                          bool evenOrOdd);

extern "C" __global__ void getSendFsPost27(real* DD,
										   real* bufferFs,
										   int* sendIndex,
                                           int buffmax,
                                           unsigned int* neighborX,
                                           unsigned int* neighborY,
                                           unsigned int* neighborZ,
                                           unsigned int size_Mat, 
                                           bool evenOrOdd);

extern "C" __global__ void setRecvFsPre27(real* DD,
										  real* bufferFs,
										  int* recvIndex,
                                          int buffmax,
                                          unsigned int* neighborX,
                                          unsigned int* neighborY,
                                          unsigned int* neighborZ,
                                          unsigned int size_Mat, 
                                          bool evenOrOdd);

extern "C" __global__ void setRecvFsPost27(real* DD,
										   real* bufferFs,
										   int* recvIndex,
                                           int buffmax,
                                           unsigned int* neighborX,
                                           unsigned int* neighborY,
                                           unsigned int* neighborZ,
                                           unsigned int size_Mat, 
                                           bool evenOrOdd);

extern "C" __global__ void WallFunction27(  int inx,
											int iny,
											real* vx,
											real* vy,
											real* vz,
											real* DD, 
											int* k_Q, 
											real* QQ,
											unsigned int sizeQ,
											int kQ, 
											real om1, 
											unsigned int* neighborX,
											unsigned int* neighborY,
											unsigned int* neighborZ,
											unsigned int size_Mat, 
											bool evenOrOdd);

extern "C" __global__ void LBSetOutputWallVelocitySP27( real* vxD,
														real* vyD,
														real* vzD,
														real* vxWall,
														real* vyWall,
														real* vzWall,
														int numberOfWallNodes, 
														int* kWallNodes, 
														real* rhoD,
														real* pressD,
														unsigned int* geoD,
														unsigned int* neighborX,
														unsigned int* neighborY,
														unsigned int* neighborZ,
														unsigned int size_Mat,
														real* DD,
														bool evenOrOdd);

extern "C" __global__ void GetVeloforForcing27( real* DD, 
												int* bcIndex, 
												int nonAtBC, 
												real* Vx,
												real* Vy,
												real* Vz,
												unsigned int* neighborX,
												unsigned int* neighborY,
												unsigned int* neighborZ,
												unsigned int size_Mat, 
												bool evenOrOdd);

extern "C" __global__ void InitParticles( real* coordX,
										  real* coordY,
										  real* coordZ, 
										  real* coordParticleXlocal,
										  real* coordParticleYlocal,
										  real* coordParticleZlocal, 
										  real* coordParticleXglobal,
										  real* coordParticleYglobal,
										  real* coordParticleZglobal,
										  real* veloParticleX,
										  real* veloParticleY,
										  real* veloParticleZ,
										  real* randArray,
										  unsigned int* particleID,
										  unsigned int* cellBaseID,
										  unsigned int* bcMatD,
										  unsigned int* neighborX,
										  unsigned int* neighborY,
										  unsigned int* neighborZ,
										  unsigned int* neighborWSB,
										  int level,
									      unsigned int numberOfParticles, 
										  unsigned int size_Mat);

extern "C" __global__ void MoveParticles( real* coordX,
										  real* coordY,
										  real* coordZ, 
										  real* coordParticleXlocal,
										  real* coordParticleYlocal,
										  real* coordParticleZlocal,
										  real* coordParticleXglobal,
										  real* coordParticleYglobal,
										  real* coordParticleZglobal,
										  real* veloParticleX,
										  real* veloParticleY,
										  real* veloParticleZ,
										  real* DD,
										  real  omega,
										  unsigned int* particleID,
										  unsigned int* cellBaseID,
										  unsigned int* bcMatD,
										  unsigned int* neighborX,
										  unsigned int* neighborY,
										  unsigned int* neighborZ,
										  unsigned int* neighborWSB,
										  int level,
										  unsigned int timestep, 
										  unsigned int numberOfTimesteps, 
									      unsigned int numberOfParticles, 
										  unsigned int size_Mat,
										  bool evenOrOdd);

extern "C" __global__ void MoveParticlesWithoutBCs(   real* coordX,
													  real* coordY,
													  real* coordZ, 
													  real* coordParticleXlocal,
													  real* coordParticleYlocal,
													  real* coordParticleZlocal,
													  real* coordParticleXglobal,
													  real* coordParticleYglobal,
													  real* coordParticleZglobal,
													  real* veloParticleX,
													  real* veloParticleY,
													  real* veloParticleZ,
													  real* DD,
													  real  omega,
													  unsigned int* particleID,
													  unsigned int* cellBaseID,
													  unsigned int* bcMatD,
													  unsigned int* neighborX,
													  unsigned int* neighborY,
													  unsigned int* neighborZ,
													  unsigned int* neighborWSB,
													  int level,
													  unsigned int timestep, 
													  unsigned int numberOfTimesteps, 
													  unsigned int numberOfParticles, 
													  unsigned int size_Mat,
													  bool evenOrOdd);

extern "C" __global__ void initRandom(curandState* state);

extern "C" __global__ void generateRandomValues(curandState* state, 
												real* randArray);


#endif
							 